#ifndef FILESHDR
#define FILESHDR

#include "runsettings.h"

#include <iostream>
#include <fstream>
#include <string>

class Files {
 public:
  Files(const RunSettings& rs) : printAllTrees(rs.getPrintAllTrees())  {
    int ok=1;
    openFile(rs,".lpd",flogp,ok);
    openFile(rs,".top",ftop,ok);
    openFile(rs,".out",fout,ok);
    if(printAllTrees)
      openFile(rs,".tre",ftree,ok);
    openFile(rs,".acc",facc,ok);
    if(!ok)
      quit(1);
  }
  ~Files() { 
    flogp.close();
    ftop.close();
    fout.close(); 
    if(printAllTrees)
      ftree.close(); 
    facc.close();
  }
  ofstream ftop,fout,ftree,flogp,facc;
 private:
  int printAllTrees;
  void openFile(const RunSettings&,const string,ofstream&,int&);
};

#endif
