#ifndef MYFUN_H
#define MYFUN_H

//const double prec=pow(10.0, -16);
const double prec=0.0;

double min(double x, double y){
  if(x-y < -prec) {return x;}
  else {return y;}
}
  
double max(double x, double y){
  if(x-y > prec) {return x;}
  else {return y;}
}

void ascend(int k,/*inout*/ double a[]){
  double temp;
  int minIndex;

  for(int i=0; i<k-1; i++){
    minIndex = i;

    for(int j=i+1; j<k; j++){
      if(a[j]<a[minIndex]){
	minIndex = j;
      }
    }

    temp = a[minIndex];
    a[minIndex] = a[i];
    a[i] = temp;
  }
}



long factorial(int k){        //k!
  long temp=1;
  for(int i=2; i<=k; i++){
    temp = temp * i;
  }
  return temp;
}


double choose(int m, int n){    // C(m,n)=m!/(n!*(m-n)! = m*(m-1)*...*(n+1) / ((m-n)*(m-n-1)*...*1), m>=n
  double temp=1.0;
  for(int i=1; i<=m-n; i++){
    temp = double(temp) * double(i+n) / double(i);
  }
  return temp;
}

/*
void TPMatrix(double p, double prob[r+1][r+1])          //TP: transition probability
{
  int lowbd, upbd;                               //the lower and up bound of loop

  for(int i=0; i<=r; i++){
    for (int j=0; j<=r; j++){
      prob[i][j]=0;
    }
  }

  //get the transition probability matrix
  for(int j=0; j<=r; j++){
    for (int k=0; k<=r; k++){
      lowbd = (j-k>0 ? (j-k):0);        //max(0,j-k);
      upbd = (j<r-k ? j:(r-k));           //min(j,r-k);

      for(int m=lowbd; m<=upbd; m++){
        prob[j][k] = prob[j][k] + choose(r-j, k-j+m) * pow(p,k-j+m) * pow(1-p, r-k-m) * choose(j,m) * pow(p/3,m) * pow(1-p/3, j-m);
      }
    }
  }
}
*/

double transProb(int r, int j, int k, double theta, double Time)   
     // r: the size of marker
     // j,k: the number of mismatches, 0 <= j,k <= r
     // theta: substitution rate per unit time
{
  int lowbd, upbd;                               //the lower and up bound of loop
  double p = 3 * (1-exp(-4*theta*Time/3)) / 4;
  double transprob = 0.0;

  lowbd = ((j-k>0) ? (j-k):0); //max(0,j-k);
  upbd = ((j<r-k) ? j:(r-k));  //min(j,r-k);

  for(int m=lowbd; m<=upbd; m++){
    transprob = transprob + choose(r-j, k-j+m) * pow(p,k-j+m) * pow(1-p, r-k-m) * choose(j,m) * pow(p/3,m) * pow(1-p/3, j-m);
  }

  return(transprob);
}



double priorN0(int N0){          
  // assume JC model: p1=p2=p3=p4=.25, independent
  return pow(double(4079)/double(4096), double(N0-1)) * double(17) / double(4096);
}

double priorM0(int M0){
  return 1.0;
}

double proposeN0(int N0, int Mark1, int Mark2, double r){
  int minMark, maxMark;
  if(Mark1<Mark2){
    minMark = Mark1;
    maxMark = Mark2;
  }
  else{
    minMark = Mark2;
    maxMark = Mark1;
  }

  double prob;
  if(N0>=minMark && N0<=maxMark){
    prob = .9/double(maxMark-minMark+1);
  }
  else if(N0<minMark){
    prob = .05 * r * pow(1-r, N0-1) / (1-pow(1-r, minMark-1));
  }
  else{
    prob = .05 * r * pow(1-r, N0-maxMark-1);
  }
  return prob;
}


void InitCutter(int& a, int&b, int& sumab)
{
    int temp = rand()%33;
    if(temp <1){
      a = 9;
      b = 9;
      sumab = 18;
    }
    else if(temp < 17){
      a = 9;
      b = 7;
      sumab = 16;
    }    
    else{
      a = 7;
      b = 9;
      sumab = 16;
    }
}
#endif
